'
'   \[XFhttp://d.hatena.ne.jp/barycentric/20091022/1256225627
'
'    {R[h́ALTCg̓]pAςłB
'
Class TabControlEx

    Inherits TabControl

    Private mouseDownPointX As Integer = 0
    Private mouseDownPointY As Integer = 0
    Private dragBoxFromMouseDown As Rectangle = Rectangle.Empty

    Public Sub New()

        AllowDrop = True
        ClearDragTarget()

    End Sub

    Protected Overrides Sub OnDragOver(e As System.Windows.Forms.DragEventArgs)

        MyBase.OnDragOver(e)

        'hovering over^u𓾂D
        Dim hoverTab As TabPage = _
            GetTabPageByTab(PointToClient(New Point(e.X, e.Y)))

        '^uL`ƎĂ邩ǂŏ
        If hoverTab IsNot Nothing _
            AndAlso e.Data.GetDataPresent(GetType(TabPage)) Then

            ' TabPagëړubNۂ̋Lq
            ' hbṽLZ
            ' ၫ
            'If hoverTab.Text.Equals("Tab1") Then
            '    Return
            'Else
            'End If

            '^u擾łꍇ̏
            e.Effect = DragDropEffects.Move

            Dim draggedTab As TabPage = _
                DirectCast(e.Data.GetData(GetType(TabPage)), TabPage)

            Dim srcTabIndex As Integer = FindIndex(draggedTab)
            Dim dstTabIndex As Integer = FindIndex(hoverTab)

            If Not srcTabIndex.Equals(dstTabIndex) Then

                Me.SuspendLayout()
                '厖
                Dim tmp As TabPage = TabPages(srcTabIndex)

                TabPages(srcTabIndex) = TabPages(dstTabIndex)
                TabPages(dstTabIndex) = tmp

                SelectedTab = draggedTab
                '厖
                Me.ResumeLayout()

            Else
            End If

        Else
            '^u擾łȂꍇ̏
            'Ȃėǂ
            e.Effect = DragDropEffects.None
        End If

    End Sub

    Protected Overrides Sub OnMouseMove(e As MouseEventArgs)

        MyBase.OnMouseMove(e)

        If Not dragBoxFromMouseDown.Equals(Rectangle.Empty) _
            AndAlso Not dragBoxFromMouseDown.Contains(e.X, e.Y) Then

            If Me.TabCount < 2 Then
                Return
            Else
            End If

            Dim objtab As TabPage = _
                GetTabPageByTab(New Point(mouseDownPointX, mouseDownPointY))

            ' TabPagëړubNۂ̋Lq
            ' hbÕLZ
            ' ၫ
            'If objtab.Text.Equals("Tab1") Then
            '    Return
            'Else
            'End If

            If objtab IsNot Nothing Then
                DoDragDrop(objtab, DragDropEffects.All)
            Else
            End If

        Else
        End If

    End Sub

    Protected Overrides Sub OnMouseUp(e As MouseEventArgs)

        MyBase.OnMouseUp(e)
        ClearDragTarget()

    End Sub

    Protected Overrides Sub OnMouseLeave(e As EventArgs)

        MyBase.OnMouseLeave(e)
        ClearDragTarget()

    End Sub

    Private Sub ClearDragTarget()

        dragBoxFromMouseDown = Rectangle.Empty
        mouseDownPointX = 0
        mouseDownPointY = 0

    End Sub

    Protected Overrides Sub OnMouseDown(e As MouseEventArgs)

        MyBase.OnMouseDown(e)
        ClearDragTarget()

        If Not e.Button.Equals(MouseButtons.Left) OrElse e.Clicks > 1 Then
            Return
        Else

            Dim dragSize As Size = SystemInformation.DragSize

            dragBoxFromMouseDown = _
                New Rectangle(New Point(e.X - (dragSize.Width / 2), _
                                        e.Y - (dragSize.Height / 2)), dragSize)
            mouseDownPointX = e.X
            mouseDownPointY = e.Y

        End If

    End Sub

    'GetTabPageByTab : Point --> TabPage + {null}
    Private Function GetTabPageByTab(pt As Point) As TabPage

        For i As Integer = 0 To TabPages.Count - 1

            If GetTabRect(i).Contains(pt) Then
                Return TabPages(i)
            Else
            End If

        Next

        Return Nothing

    End Function

    'FindIndex: TabPage --> Int + { null }
    Private Function FindIndex(page As TabPage) As Integer

        For i As Integer = 0 To TabPages.Count - 1

            If TabPages(i).Equals(page) Then
                Return i
            Else
            End If

        Next

        Return -1

    End Function

End Class